# class method > class wide attributes with a class method, instead of passing the value thru an instance from the application
# page 57

class Order:
    # class wide (e.g. global) attribute to be used everywhere in the app
    tax_rate = 0.05 # 80 % taxable

    # class method for the class-wide attribute
    @classmethod
    def set_tax_rate(cls, new_tax_rate): # override with 0 if tax exempt
        #prop = param
        cls.tax_rate = new_tax_rate

    # instance method
    # amount order1  tax_rate  #classmethod
    def calculate_total(self):
        return self.amount + (self.amount * Order.tax_rate)
        # return instance.attr (from self) and class.attr

    # instance method to define 2 attr of the instance
    # these values will be passed from creating the instance object in the application
    def __init__(self, order_id, amount):
        self.order_id = order_id
        self.amount = amount

# Application
order1 = Order("1234ABCD", 500)
print(f"Order ID:  {order1.order_id}  Total with Tax Rate:  ${order1.calculate_total():.2f}")