# PersonProp.py
# @property annotator
# define @property use setter to set property value

class PersonProp:

    # 2 attrs for the class
    def __init__(self,firstname, lastname):
        self.firstname = firstname
        self.lastname = lastname

    # Property for the Class
    @property
    def prop_fullname(self): # call prop_fullname()
        return f"{self.firstname} {self.lastname}"  # Bob Smith

    @prop_fullname.setter
    def prop_fullname(self, name): #Jane Doe
        self.name = name

# Application
person1 = PersonProp("Bob","Smith") # prop = Class()
# instance method for fullname
fullname = person1.firstname + " " + person1.lastname
print(fullname) #Bob Smith instance

# using the fullname prop for the instance of the class person1
print(person1.prop_fullname)  # prop_fullname NOT method name prop_fullname()

# using the fullname prop with a getter and setter
person1.prop_fullname = "Jane Doe"
print(person1.name) # Jane Doe from name property setter