# Page 57 Static Methods
#  Product.py
#  instance methods belongs to the INSTANCE (contact1 = Contact()) of the class object
# static method belongs to the CLASS (Product) rather than any particular instance

class Product:  # 2 attrs name, price

    # initialize 2 attrs page 53-55
    def __init__(self, name, price):
        self.name = name
        self.price = price 

    # static method
    @staticmethod  # method name has to be on next line
    def apply_discount(price, discount):
        return price * (1 - discount)

# Application
# Step 1 create an instance of the class Product and pass name and price attr
product1 = Product("Widget 1", 1000)  #instance of the Class Object

# Using the INSTANCE not the CLASS product1.x
print(f"Product Name : {product1.name} Product Original Price:  {product1.price}")

# Using the method from the CLASS Product.x @staticmethod
discounted_price = Product.apply_discount(1000,0.10)  #  1000 * (1-.10) 900 
print("Discounted Price: " + str(discounted_price))  # resource intensive
print(f"Discounted Price:  {discounted_price}")  # memory/resource friendly